#!/usr/bin/perl

#########################################################
#                                                       #
#             MaximumEdge.com News Headlines            #
#                                                       #
#########################################################
#                                                       #
#   This perl script will fetch news headlines from     #
#   MaximumEdge.com and display them on your site.      #
#                                                       #
#   To install this script simply upload it to your     #
#   CGI-BIN and CHMOD it 755. You will also have to     #
#   rename is to "newsheadlines.txt" for it to work.    #
#   You may also have to change the first line of this  #
#   script to the correct location of perl on your web  #
#   server. On any page where you want headlines to     #
#   appear, rename the page ending with '.shtml' and    #
#   add this code:                                      #
#                                                       #
#   <!--#include virtual="newsheadlines.cgi?top"-->     #
#                                                       #
#   Make sure that it point to the correct directory.   #
#   Replace "top" with whatever headlines you wish      #
#   to use. Your choices are "top", "entertainment",    #
#   "business", "sports", and "health".                 #                               #
#                                                       #
#   If you have any questions or comments regarding     #
#   this script please go to                            #
#   http://www.maximumedge.com/contact.shtml            #
#                                                       #
#########################################################

use LWP::Simple;
use LWP::UserAgent;
print "Content-type:text/html\n\n";
print "<ul>";
if ($ENV{'QUERY_STRING'} eq "entertainment" || $ENV{'QUERY_STRING'} eq "business" || $ENV{'QUERY_STRING'} eq "sports" || $ENV{'QUERY_STRING'} eq "health") {
$url = "http://www.maximumedge.com/cgi/news/$ENV{'QUERY_STRING'}.txt";
}
else {
$url = "http://www.maximumedge.com/cgi/news/top.txt";
}
my $ua = new LWP::UserAgent;
my $res = $ua->request(HTTP::Request->new(GET => $url));
my $content = $res->content;
@lines = split("\n",$content);
foreach $line (@lines) {
@parts = split(/\|/,$line);
print "<li><font face=\"Arial\"><a href=\"http://www.maximumedge.com/cgi/news/article.cgi/$parts[0]\">$parts[1]</a></font> <font face=\"Arial\" size=\"1\">$parts[2]</font></li>";
}
print "</ul>";
