#------------------------------------------------------------------------
#                              getmessage.pl  v2.0
# getmessage.pl is to be used in combination with
# qdpop.pl to view messages in a standard POP3 account 
# by message id.  Authentication information is passed with
# cookies.
#
# QD-POP: Quick and Dirty POP mail cgi client.
# Copyright (c) 1997 David B. Hill,MD (dbhill@ucdavis.edu)
#                       and
#                 Michael Hogarth,MD (mahogarth@ucdavis.edu
# Copying terms: GNU General Public License
# Credits: Sean Dowd <ssd@mmts.eds.com> for POP3Client
#		   Lincoln D. Stein <lstein@genome.wi.mit.edu> for CGI.PM
#
#  changes in version 1.1: removal of dependence on CGI.pm.
#--------------------------------------------------------------------------

#load POP3Client.pm module from /Lib/mail in the PERL directories
##the location described above may only be valid on Unix boxes. -dbh
use Mail::POP3Client;


#obtain the FORM information that has been passed by using
#the param() method of the cgi object.
&ReadParse;
$loginname =  $in{'loginname'};
$password =   $in{'password'};
$POPserver =  $in{'POPserver'};
$i =          $in{'id'};
$cache     =  $in{'cache'};

$browser = $ENV{'HTTP_USER_AGENT'};

#clear the $body variable.
$body ="";

#create a POP connection using the POP3client module by
#creating an object called $pop of type POP3Client. See 
#POP3Client.pm documentation.
$pop = new Mail::POP3Client($loginname, $password, $POPserver);

print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>QD-POP";
print "</TITLE>";
if ($cache eq "No") {	print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>"; }

if ($browser =~ /Mozilla\/2/) {
	print "<SCRIPT LANGUAGE='JavaScript'><!-- Hide JavaScript from old browsers\n";
	print "function goBack()\n";
	print "{\n";   
	print "history.go(-1)\n";
	print "}\n";
	print "//---- End hiding JavaScript --></SCRIPT>\n";
	}
print "</HEAD>";
print "<BODY BGCOLOR='FFFFFF'>";

print "<font size='+2'>Message $i</font>";
print "<hr>";


#POP the header...
&GetHeader();


#POP the message using POP3Client's body() function
#and add a line return at the end of each line. Otherwise
#the thing will look awful.
foreach ($pop->Body($i)) {
			$body = $body.$_."\n";
	}


#Note that $from2 was
#created in &GetHeader.  If an @ was in $from, then
#the electronic address should be found in $from2, else
#it will contain just the first part of the original string.


if ($sub eq "Subject:") {
	$sub = ">>no subject<<";
	}

print "<TABLE border=0><TR><TD>";
print "TO:         $to       <br>\n";
print "FROM:    <b>$from2</b><br>\n";
print "SUBJECT: <b>$sub</b>  <br>\n";
print "Date:       $date</td>    \n";

if ($browser eq "Mozilla\/2") {
	print "<TD WIDTH=100 ALIGN=CENTER>\n<FORM METHOD='Post'>";
	print "<INPUT TYPE='button' VALUE='Back' onClick='goBack()'>";
	print "</FORM></TD>\n";
	}
else {
	print "<TD><FORM METHOD='POST'  ACTION='/cgi-shl/qdpop/qdpop.pl'     >\n";
	print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname   >\n";
	print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver   >\n";
	print "<INPUT TYPE='hidden' NAME='password'   VALUE=$password    >\n";
	print "<INPUT TYPE='hidden' NAME='lastMsg'    VALUE=($i+1)       >\n";
	print "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache    >\n";
	print "<INPUT TYPE='submit'                   VALUE='Back'       >\n";
	print "</FORM></TD>";
	}


# Now create a button which will enable a user to generate a reply.
# As usual, the button is loaded with hidden values to permit a message
# to actually be sent at a later time.

	if ($replyto == '') { $replyto = $from2;  }
	$sub = 're: '.$sub;
	print "<TD WIDTH=100 ALIGN=CENTER>\n";
	print "<FORM METHOD='POST' ACTION='/cgi-shl/qdpop/makeReply.pl'>\n";
	print "<INPUT TYPE='submit'                       VALUE='Reply'>\n";
	print "<INPUT TYPE='hidden'  NAME='loginname'     VALUE=$loginname>\n";
	print "<INPUT TYPE='hidden'  NAME='password'      VALUE=$password>\n";
	print "<INPUT TYPE='hidden'  NAME='POPserver'     VALUE=$POPserver>\n";
	print "<INPUT TYPE='hidden'  NAME='to'            VALUE='$replyto'>\n";
	print "<INPUT TYPE='hidden'  NAME='subject'       VALUE='$sub'>\n";
	#print "<INPUT TYPE='hidden'  NAME='body'          VALUE=$body>\n";
	print "<INPUT TYPE='hidden'  NAME='cache'         VALUE=$cache>\n";
	print "</FORM></TD>\n"; 

#for each message header, also provide a FORM button to
#delete using qdpop.pl As above, pass in the needed vars
#using hidden types.
	print "<TD WIDTH=100 ALIGN=CENTER>\n";
	print "<FORM METHOD='POST' ACTION='/cgi-shl/qdpop/qdpop.pl'>\n";
	print "<INPUT TYPE='submit'                   VALUE='Delete'   >\n";
	print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname >\n";
	print "<INPUT TYPE='hidden' NAME='password'   VALUE=$password  >\n";
	print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver >\n";
	print "<INPUT TYPE='hidden' NAME='deleteMsg'  VALUE=$i         >\n";
	print "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache  >\n";

	print "</FORM></TD></TR></TABLE>";

#print the message body using 'pre' tags to
#standardize the font. Otherwise, if someone has the
#font settings set too big, the message will look
#awful. We don't want that.
#
#Unfortunatley, a side effect is that single-line paragraphs
#will need to be scrolled left&right to be able to be read.
print "<hr><b>MESSAGE:</b><pre>$body</pre>\n";


#close the POP connection using the close() method
$pop->Close();

#send the ending html code (/body and /head tags)
print "</BODY></HTML>\n";
  exit(0);


#-----------------------------SUBROUTINES------------------------



sub ReadParse {
  local(*in)=@_ if @_;
  local ($i,$key,$val);

  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in=$ENV{'QUERY_STRING'};
  }
  elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  
  @in=split(/&/,$in);
  
  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key,$val)=split(/=/,$in[$i],2);
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "\0" if (defined($in{$key}));
    $in{$key} .=$val;
  }
  return length($in);
}



##############################
#  GetHeader Subroutine      #
##############################

sub GetHeader {
	
	#for the message identified by the 'id'
	#passed in the FORM, POP the header to
	#get the 'Subject' and 'From' info. Why? Because if the 
	#are passed in the header and one is greater than 256 characters
	#the browser will chop it off.
	#This is unlikely, but we want to cover any
	#eventuality.
	foreach ($pop->Head($i)) {
		
		#parse out the From line from the header.
		#Also, remove any angle brackets
		#since some SMTP servers choke on these, but
		#some POP clients send them anyway.  (Not to mention
		#but browsers tend to ignore them as unknown
		#HTML codes.
		if (/^From:/ ){
			$from = $_;				#assign the targeted line to the variable
			$from =~ s/From:\s+//;  #remove leading "From:" and any following whitespace
			$from =~s/\"//g;		#remove any quote marks & match contents
			if ($from =~/\<(.*\@.*)\>/) { #delete angle brackets & match anything inside w/ "@"
				$from2 = $1;	    #use electronic address, if available
			}
			else {
				$from2 = $from;	    #else, use the quoted name
			}
		}# end if From
		
		#parse out the "reply-to" line, if it exists...
		$replyto = '';			#create the variable, but leave it empty
		if (/^Reply-To:/) {
			$replyto = $';
			$replyto =~ s/\s+//;	#remove intervening white space
			$replyto =~ s/\</&lt\;/;	  #make angle brackets browser safe
			$replyto =~ s/\>/&gt\;/;
			}


	
		#parse out the subject line.
		if  (/^Subject:/) {
			#once the target phrase is found,
			#capture everything following it with the
			# $' PERL system function.
			$sub = $';
			$sub =~ s/\s+//;   #remove leading white space
			}
			
		#parse out the date line.
		if  (/^Date:/) {
			#once the target phrase is found,
			#capture everything following it with the
			# $' PERL system function.
			$date = $';
			$date =~ s/\s+//;   #remove leading white space
			}
			
		#parse out the recipient line.
		if (/^To:/) {
			#once the target phrase is found,
			#capture everything following it with the
			# $' PERL system function.
			$to = $';
			$to =~ s/\s+//;   	  #remove leading white space
			$to =~ s/\</&lt\;/;	  #make angle brackets browser safe
			$to =~ s/\>/&gt\;/;
			
		}
	}
}
