#------------------------------------------------------------------------
#                              sendReply.pl  v2.0

use Socket;

#obtain the FORM information that has been passed by using
#the param() method of the cgi object.
&ReadParse;
$loginname = $in{'loginname'};
$password  = $in{'password'};
$POPserver = $in{'POPserver'};
$sender    = $in{'sender'};
$to        = $in{'to'};
$subject   = $in{'subject'};
$message   = $in{'message'};
$cache     = $in{'cache'};


#######################################################################
#the SMTPserver could be set as a user variable, but the average user
#doesn't know the difference between POP and SMTP servers, especially
#when one host provides both services.  Typically, SMTP servers are
#now using IP filtering to reduce spam-jacking, so this variable 
#should only be set by the QD-POP administrator for each specific 
#site.

$SMTPserver = "";

#######################################################################


$status = sendmail($sender, $sender,  $to, $SMTPserver, $subject, $message);


#output the header to the client browser (DO NOT DELETE).
#lack of this will result in an error 500.
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>QD-POP_Message_Sent</TITLE>";
if ($cache eq "No") { print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>"; }


print "<SCRIPT LANGUAGE='JavaScript'>\n";
print "function closeThisWindow() { \n";
print "window.close()\n";
print "}\n";
print "</SCRIPT>\n";

print "</HEAD><BODY BGCOLOR='FFFFFF'>";

if    ($status ==  1) {print " Your email has been sent.";
					   print "<img src='/qdpop/MailAnimation.gif'>";
					   } 
elsif ($status == -1) {print " The smtp host, <I>$smtp</I>, is unknown.";}
elsif ($status == -2) {print " Creation of the socket failed.";}
elsif ($status == -3) {print " Unable to connect.";}
elsif ($status == -4) {print " The service you requested is not available";}
elsif ($status == -5) {print " An unspecified communication error occured.";}
elsif ($status == -6) {print " Local user <I>$to</I> unknown on host <I>$smtp</I>.";}
elsif ($status == -7) {print " Transmission of message failed.  Sorry.";}
elsif ($status == -8) {print " Who are you sending this to?";}
else                  {print " Unknown error status.  Sorry. ";}

print "<table><tr><td>";
print "<FORM METHOD='POST'  ACTION='/cgi-shl/qdpop/qdpop.pl'     >\n";
print "<INPUT TYPE='SUBMIT'                   VALUE='OK'         >\n";
print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname   >\n";
print "<INPUT TYPE='hidden' NAME='password'   VALUE=$password    >\n";
print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver   >\n";
print "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache       >\n";

print "</FORM>";

print "</td><td>";
		# Lastly, provide a button which will let the user 'Logout'.  This 
		# actually closes the window in use in order to destroy the history log
		# which contains the all previously viewed email, plus the clear text
		# login/password/host information that would allow an intruder access
		# to the account in the future.
		print "<FORM METHOD='Post'>";
		print "<INPUT TYPE='button' VALUE='Logout' onClick='closeThisWindow()'>";
		print "</FORM></td></tr></table>\n";

#send the ending html code (/body and /head tags)
print "</BODY></HTML>";

#-----------------------------SUBROUTINES------------------------



sub ReadParse {
  local(*in)=@_ if @_;
  local ($i,$key,$val);

  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in=$ENV{'QUERY_STRING'};
  }
  elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  
  @in=split(/&/,$in);
  
  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key,$val)=split(/=/,$in[$i],2);
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "\0" if (defined($in{$key}));
    $in{$key} .=$val;
  }
  return length($in);
}


#------------------------------------------------------------
# sub sendmail()
#
# send/fake email around the world ...
#
# Version : 1.21
# Environment: Hip Perl Build 105 NT 3.51 Server SP4
# Environment: Hip Perl Build 110 NT 4.00
#
# arguments:
#
# $from email address of sender
# $reply email address for replying mails
# $to email address of reciever
# (multiple recievers can be given separated with space)
# $smtp name of smtp server (name or IP)
# $subject subject line
# $message (multiline) message
#
# return codes:
#
# 1 success
# -1 $smtphost unknown
# -2 socket() failed
# -3 connect() failed
# -4 service not available
# -5 unspecified communication error
# -6 local user $to unknown on host $smtp
# -7 transmission of message failed
# -8 argument $to empty
#
# usage examples:
#
# print
# sendmail("Alice <alice\@company.com>",
# "alice\@company.com",
# "joe\@agency.com charlie\@agency.com",
# $smtp, $subject, $message );
#
# or
#
# print
# sendmail($from, $reply, $to, $smtp, $subject, $message );
#
# (sub changes $_)
#
#------------------------------------------------------------

################################################################
### sendmail ###################################################
################################################################
sub sendmail {

my ($from, $reply, $to, $smtp, $subject, $message) = @_;

my ($fromaddr) = $from;
my ($replyaddr) = $reply;

$to =~ s/[ \t]+/, /g; # pack spaces and add comma
$fromaddr =~ s/.*<([^\s]*?)>/$1/; # get from email address
$replyaddr =~ s/.*<([^\s]*?)>/$1/; # get reply email address
$replyaddr =~ s/^([^\s]+).*/$1/; # use first address
$message =~ s/^\./\.\./gm; # handle . as first character
$message =~ s/\r\n/\n/g; # handle line ending
$message =~ s/\n/\r\n/g;
$smtp =~ s/^\s+//g; # remove spaces around $smtp
$smtp =~ s/\s+$//g;

if (!$to) { return -8; }

my($proto) = (getprotobyname('tcp'))[2];
my($port) = (getservbyname('smtp', 'tcp'))[2];

my($smtpaddr) = ($smtp =~
/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
? pack('C4',$1,$2,$3,$4)
: (gethostbyname($smtp))[4];

if (!defined($smtpaddr)) { return -1; }

if (!socket(S, AF_INET, SOCK_STREAM, $proto)) { return -2; }
if (!connect(S, pack('Sna4x8', AF_INET, $port, $smtpaddr))) { return -3; }

my($oldfh) = select(S); $| = 1; select($oldfh);

$_ = <S>; if (/^[45]/) { close S; return -4; }

print S "helo localhost\r\n";
$_ = <S>; if (/^[45]/) { close S; return -5; }

print S "mail from: <$fromaddr>\r\n";
$_ = <S>; if (/^[45]/) { close S; return -5; }

foreach (split(/, /, $to)) {
print S "rcpt to: <$_>\r\n";
$_ = <S>; if (/^[45]/) { close S; return -6; }
}

print S "data\r\n";
$_ = <S>; if (/^[45]/) { close S; return -5; }

print S "To: $to\r\n";
print S "From: $from\r\n";
print S "Reply-to: $replyaddr\r\n" if $replyaddr;
print S "X-Mailer: Perl Sendmail Version 1.21 Christian Mallwitz Germany\r\n";
print S "Subject: $subject\r\n\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>; if (/^[45]/) { close S; return -7; }

print S "quit\r\n";
$_ = <S>;

close S;
return 1;
}