#!/usr/local/bin/perl


                         ### *** IMPORTANT *** ###

         ### *** Make sure the path to PERL above is correct *** ###
   
                   ## Could be any of the following:

                   ###!/usr/local/bin/perl
                   ###!/usr/local/bin/perl
                   ###!/usr/local/bin/perl5


      #################################################################
      #                                                               #
      #                          Ultra HTML                           #
      #                                                               #
      #                   WEb Page Builder Program                    #
      #                              by                               #
      #                        Ranson Johnson                         #
      #                                                               #
      #                                                               #
      # Special modification for webondisk                            #
      #                                                               #
      #                                                               #
      # E-Mail: ranson@rlaj.com                                       #
      #                                                               #
      # Script name: ultra-conf.pl  (Configuration File)              #
      #                                                               #
      # Copywrite 1997/1999 by Ranson's Scripts all rights reserved   #
      # Sale or re-distribution of this program without prior written #
      # permision is prohibited.                                      #
      #                                                               #
      #################################################################


                      ### *** IMPORTANT *** ###

### *** If FTP'ing this file, be sure to send in ASCII format *** ###

# You must chmod the cgi's to 755 
# For information on chmod see Ranson's FAQ's

#    Configure the varialbles in the configuration section below
#    be careful to not disturb the single (') or double quotes (") 
#    surounding each variable, or the semicolon (;) at the end of 
#    each line.

# The 'Path' to the files so Perl can find them is essential.
# The path below is - /usr/home/rlaj/cgi-bin/preformat/FILENAME
# Help with the path on your server can be found at:
# http://www.tennet.com/faq/install.htm


                 ### *** DIRECTORY STRUCTURE *** ###

# NOTE: For Windows NT you may need to change the extention of the .cgi's
# to .pl - Some servers require the program files to have the (.pl) ext.

## ** Recomended Directory Structure
#
#
#
#             Root (Your Main Directory)
#               |               
#               |
#               preformat (Main Builder Directory)
#                       |
#                       |
#                      admin (your administration page)
#                       |
#                       |
#                      bkgrnd (all background images)
#                       |
#                       |
#                      commonimages (images used by the builder)
#                       |
#                       |
#                      data (user data file storage)
#                       |
#                       |
#                      formmail (formmail setup information)
#                       |
#                       |
#                      forms (program forms)
#                       |
#                       |
#                      help (user help files)
#                       |
#                       |
#                      image_library (images for user use within the program)
#                       |
#                       |
#                      page_library (HTML menu pages for the image library)
#                       |
#                       |
#                      templates (templates used by the program to generate pages)
#
#
## ** CGI DIRECTORY
#
#
#          cgi-bin                       
#               |
#               |
#               add-user.cgi  (Administrator program to add users)
#               |
#               |
#               admin.cgi  (Administrator program to remove or change access
#               |           for users)
#               |
#               background.cgi  (page colors)
#               |
#               |
#               bg.cgi (background viewer)
#               |
#               |
#               editmenu.cgi (menu editor)
#               |
#               |
#               form.cgi (displays user forms)
#               |
#               |
#               new-user.cgi (user self-setup program)
#               |
#               |
#               opening.cgi (login program)
#               |
#               |
#               pagedit.cgi (user page editor)
#               |
#               |
#               password.log (user passwords)
#               |
#               |
#               preview.cgi (preview for user page)
#               |
#               |
#               savemenu.cgi (save menu changes)
#               |
#               |
#               savepage.cgi (save user pages)
#               |
#               |
#               ultra-conf.pl (this file)
#               |
#               |
#               upload.cgi (file upload)
#               |
#               |
#               upload-login.cgi (file upload login)
#               |
#               |
#               webedit.cgi (advanced editor and file management)
#
#
#
## ** User Root Directory
#
#
#
#             Root (Your Main Directory)
#               |               
#               |             
#               USER (can be called anything you like)
#                    (this is where all user directories are created)  
#
#

              ### *** CONFIGURATION SECTION *** ###

# Enter an Administrator username and password
$username = 'admin';
$password = 'admin';

# Enter the number of pages the user is allowed to create
# This is for the 'new_user.cgi" only. Allowing users to
# set up their own account.
$new_user_pages = '5';


# Enter you domain name in the variable below '$ok_domain'
# you do not need the www.  or  the .com  just your domain name
# this is used for securiety purposes not allowing access 
# from remote sites
$ok_domain = 'info-chat';

# NOTE: see /preformat/admin/
# for information on changing the referer for the new_user.cgi
# for automated signup.


# Enter the operating system for your server
# Unix = '0' 
# NT = '1'
$operating_system = '0';


# Enter the path to the mail program
$mailprog = '/usr/sbin/sendmail';     # for UNIX

$webmaster = 'BazSoft@aol.com';

$mail_from = 'BazSoft@aol.com';

                         ### *** *** ###


            ### *** Paths for Directorys and Files *** ###

# here is a little extra sherman added in

$bpa = "/home/httpd/infochat/editor/";

###

# Enter the path for the templates directory
$template_path = '$bpa/templates';

# Enter the path for the forms directory
$form_path = '$bpa/forms';

# Enter the path for the data directory
$data_path = '$bpa/ultra/data';

# Enter the complete path to the program cgi files
$program_cgi_files = '$bpa/';

# Enter the path for the ROOT USER DIRECTORY
$savepath = '$bpa/members/';

# Enter the path to the main directory (templates, data, backgrnd, etc.)
$main_dir_path = '$bpa/';

# Enter the path and name for the password file
$passwordfile = '$bpa/etc/user.log';



                 ### *** Web Addresses *** ###


# Enter the path for the template1.htm (templates directory)
$template_dir = 'http://www.2cp.com/ultra/templates';

# Enter the web address for the User ROOT Directory
$User_URL = 'http://www.2cp.com/ultra_users';

# Enter the web address for the background images directory 
$bkgrnd_dir = 'http://www.2cp.com/ultra/bkgrnd';

# Enter the web address for the background viewer (bg.cgi)
$bgcgi = 'http://www.2cp.com/cgi-bin/editor/bg.cgi';

# Enter the URL for the 'commonimages'directory 
$common_images = 'http://www.2cp.com/ultra/commonimages';

# Enter the web address for the image library directory 
$image_library_dir = 'http://www.2cp.com/ultra/image_library';

# Enter the web address for the Ultra Easy main directory
$ultra_easy = 'http://www.2cp.com/ultra';

# Enter the web address for the mailform.pl
$mailform_pl = 'http://www.2cp.com/cgi-bin/editor/ultra-mail.pl';

# Enter the web address for the Counter (gr-count.cgi)
$counter = 'http://www.2cp.com/cgi-bin/editor/counter/gr-count.cgi';

# Enter the web address for the Help Directory
$help_dir = 'http://www.2cp.com/ultra/help';

# Enter the web address for the Page Library
$page_library = 'http://www.2cp.com/ultra/page_library/';

                         ### *** *** ###


                     ### *** OPTIONS *** ###


# Do you want to allow users to upload HTML pages to their directory
$html_upload = '1';      #   1 = yes   0 = no

# Enter the maxium size for image files to be uploaded by the user
# Enter number of bites - for 50k enter '50000'
$maxium_image_size = '50000';

# Do you want users to be able to add sound files to their pages
$allow_sound = '1';      #   1 = yes   0 = no

# If you want a link at the bottom of each user page to your home page
# or your copyright information, enter the link below.
$User_page_link = '<CENTER>This page is courtesy of <A HREF="http://www.tennet.com/">TenNet.Com</A></CENTER>';

# Pop-up-window option
# This opens a 'pop up window' on each user page used for advertising etc.
# If you want a pop up window:   1 = yes   0 = no
$pop_up_window = '0';

# Enter the full web address for the page to open for each user page
$page_to_open = 'http://www.tennet.com/preformat/popup.html';

# Enter the size of the window - width and height for the pop up 
# ( use a comma between width,height )
$pop_up_width_height = 'width=450,height=50';

# Meta Tags
# Set the meta_tags option to '1' below if you want users to be 
# able to add meta tags to their pages   1 = yes   0 = no
$meta_tags = '1';





             ### *** END OF CONFIGURATION SECTION *** ###


sub send_mail {

if ($operating_system eq '0') {  ## UNIX MAIL

                     ### *** Send Mail To User *** ###

if ($FORM{'e'} ne "" && $FORM{'e'} =~ /\w*@\w*/) {

   open (MAIL, "|$mailprog $FORM{'e'}") || &open_error($mailprog);

   print MAIL "Subject: Your New Site\n";
   print MAIL "To: $FORM{'e'}\n";
   print MAIL "From: $mail_from\n\n";

   print MAIL <<"FORMAT_YOUR_EMAIL_MESSAGE_BELOW_IN_PLAIN_TEXT";


Thank you for your new account. Your Information is below.

***************************************************************
                       ACCOUNT INFORMATION
***************************************************************

Site Name: $FORM{'username'}

UserName: $FORM{'username'}
Password: $FORM{'password'}

Login Page: $ultra_easy


Name: $FORM{'fname'} $FORM{'lname'}
Address: $FORM{'a'}
City: $FORM{'c'}
State: $FORM{'s'}
Zip: $FORM{'zip'}
Phone: $FORM{'p'}




FORMAT_YOUR_EMAIL_MESSAGE_BELOW_IN_PLAIN_TEXT


            ### *** DO NOT DISTURB THE LINE ABOVE *** ###



close (MAIL);

}

sleep(1);

               ### *** Send Mail To Webmaster *** ###

   open (MAIL, "|$mailprog $webmaster") || &open_error($mailprog);

   print MAIL "Subject: New User Information\n";
   print MAIL "To: $webmaster\n";
   print MAIL "Reply-to: $FORM{'e'}\n";
   print MAIL "From: $FORM{'e'}\n\n";


   print MAIL "\nSign-up Info for Webmaster\n\n\n";
   print MAIL "The address for the new site is:\n";
   print MAIL "/$FORM{'username'}\n\n";

   print MAIL "------------------------\n\n";

   print MAIL "Name:$FORM{'fname'} $FORM{'lname'}\n";
   print MAIL "Address: $FORM{'a'}\n";
   print MAIL "City: $FORM{'c'}\n";
   print MAIL "State: $FORM{'s'}\n";
   print MAIL "Zip: $FORM{'zip'}\n";
   print MAIL "Phone: $FORM{'p'}\n\n";


close (MAIL);

                         ### *** *** ###

 }else{            


                  ## THIS IS WINDOWS MAIL ##

$temp_msg = 'temp.mail';


               ### *** SEND MAIL TO USER *** ###


open (MAIL, ">$temp_msg") || &open_error($temp_msg);
       
        print MAIL <<"END_OF_MAIL";  
To: $webmaster
From: $in{'e'}
Subject: New User Information

Thank you for your new account. Your Information is below.

***************************************************************
                       ACCOUNT INFORMATION
***************************************************************

Site Name: $FORM{'username'}

UserName: $FORM{'username'}
Password: $FORM{'password'}

Login Page: $ultra_easy


Name: $FORM{'fname'} $FORM{'lname'}
Address: $FORM{'a'}
City: $FORM{'c'}
State: $FORM{'s'}
Zip: $FORM{'zip'}
Phone: $FORM{'p'}
END_OF_MAIL

close (MAIL);

if ($mailprog =~ /blat/i) {
system("blat.exe \"$temp_msg\" -s \"New User Information\" -f \"$mail_from\" -t $webmaster");
}
elsif ($mailprog =~ /windmail/i) {
system("\"$mailprog\" -t -t -n $temp_msg");
}
elsif ($mailprog =~ /imail/) {
system ("$mailprog -f $temp_msg -s \"New User Information\" -u $mail_from -t $webmaster");
}
unlink ("$temp_msg");

sleep(1);

               ### *** SEND MAIL TO WEBMASTER *** ###

open (MAIL, ">$temp_msg") || &open_error($temp_msg);
       
        print MAIL <<"END_OF_MAIL";  
To: $webmaster
From: $in{'e'}
Subject: New User Information

Site Name: $FORM{'username'}

UserName: $FORM{'username'}
Password: $FORM{'password'}


Name: $FORM{'fname'} $FORM{'lname'}
Address: $FORM{'a'}
City: $FORM{'c'}
State: $FORM{'s'}
Zip: $FORM{'zip'}
Phone: $FORM{'p'}
END_OF_MAIL

close (MAIL);

if ($mailprog =~ /blat/i) {
system("blat.exe \"$temp_msg\" -s \"New User Information\" -f \"$mail_from\" -t $webmaster");
}
elsif ($mailprog =~ /windmail/i) {
system("\"$mailprog\" -t -t -n $temp_msg");
}
elsif ($mailprog =~ /imail/) {
system ("$mailprog -f $temp_msg -s \"New User Information\" -u $mail_from -t $webmaster");
}
unlink ("$temp_msg");

 }
}
